<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>TASK 62_J15</h2>


    <form id="inputform01" class="jumbotron container">
     
        <div class="row form-group">
          <div class="col-sm-3">
            <label for="country">Province </label>
          </div>
          <div class="col-sm-3">
            <select id="province-select" name="province" class="form-control">
              <option value="none">select province </option>
            </select>
          </div>
        </div>
        
        <div class="row form-group">
          <div class="col-sm-3">
            <label for="country">District </label>
          </div>
          <div class="col-sm-3">
            <select id="district-select" name="district" class="form-control" disabled> 

            </select>
          </div>
        </div>

        <div class="row form-group">
          <div class="col-sm-3">
            <label for="country">Ward </label>
          </div>
          <div class="col-sm-3">
            <select id="ward-select" name="ward" class="form-control" disabled>
             
            </select>
          </div>
        </div>

    </form>
  </div>
  <script>
    
    var gProvinceSelectElement = $("#province-select");
    var gDistrictSelectElement = $("#district-select");
    var gWardSelectElement = $("#ward-select");

    //get data province
    $.ajax({
      url: "http://localhost:8081/all-provinces",
      method: "GET",
      success: function (pObjRes) {
        console.log(pObjRes);
        loadDataToProvinceSelect(pObjRes);
        
      },
      error: function (pXhrObj) {
        console.log(pXhrObj);
      }
    });

    function loadDataToProvinceSelect(provinceList) {
      for (i = 0; i < provinceList.length; i++) {
        var provinceOption = $("<option/>");
        provinceOption.prop("value", provinceList[i].id);
        provinceOption.prop("text", provinceList[i].name);
        gProvinceSelectElement.append(provinceOption);
      };
    }
   
    //get district by province id
    
    gProvinceSelectElement.on("change", function () {
        var provinceId = $(this).val();
        if (provinceId != "none"){
          gDistrictSelectElement.prop("disabled", false);
          gDistrictSelectElement.html("");
          $("<option>", {
                value: "none",
                text: "select district"
            }).appendTo(gDistrictSelectElement);

          gWardSelectElement.prop("disabled", false);
          gWardSelectElement.html("");
          $("<option>", {
              value: "none",
              text: "select ward"
          }).appendTo(gWardSelectElement);

          getDistrictByProvinceId(provinceId);
        }else {
        $("#district-select").prop("disabled", "disabled");
        $("#district-select").html("");
        gWardSelectElement.prop("disabled", "disabled");
        gWardSelectElement.html("");
        }
    });

    function getDistrictByProvinceId(paramId) {
      $.ajax({
        url: "http://localhost:8081/district_by_province_id?id=" + paramId,
        method: "GET",
        success: function (pObjRes) {
          console.log(pObjRes);
          loadDataToDistrictSelect(pObjRes);
        },
        error: function (pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }

    function loadDataToDistrictSelect(districtList) {
     
      if (districtList.length > 0) {
        
        for (i = 0; i < districtList.length; i++) {
          var districtOption = $("<option/>");
            districtOption.prop("value", districtList[i].id);
            districtOption.prop("text", districtList[i].name);
            gDistrictSelectElement.append(districtOption);
        };
      }
    }
    

    //get ward by district id
    
    gDistrictSelectElement.on("change", function () {
        var districtId = $(this).val();
      
      if (districtId != "none"){
        gWardSelectElement.prop("disabled", false);
        gWardSelectElement.html("");
        $("<option>", {
                value: "none",
                text: "select ward"
            }).appendTo(gWardSelectElement);

        getWardByDistrictId(districtId);
      }else {
        gWardSelectElement.prop("disabled", "disabled");
        gWardSelectElement.html("");
      }
    });

    function getWardByDistrictId(paramId) {
      $.ajax({
        url: "http://localhost:8081/ward-by-district-id?id=" + paramId,
        method: "GET",
        success: function (pObjRes) {
          console.log(pObjRes);
          loadDataToWardSelect(pObjRes);
        },
        error: function (pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }

    function loadDataToWardSelect(wardList) {
      if (wardList.length > 0) {
          for (i = 0; i < wardList.length; i++) {
          var wardOption = $("<option/>");
          wardOption.prop("value", wardList[i].id);
          wardOption.prop("text", wardList[i].name);
          gWardSelectElement.append(wardOption);
        };
      }
    }

  </script>
</body>

</html>

